package com.soywiz.korgw

import android.view.KeyEvent
import com.soywiz.kds.IntMap
import com.soywiz.korev.Key

object AndroidKeyMap {
    val KEY_MAP = IntMap<Key>(512).also { map ->
        map[KeyEvent.KEYCODE_A] = Key.A
        map[KeyEvent.KEYCODE_B] = Key.B
        map[KeyEvent.KEYCODE_C] = Key.C
        map[KeyEvent.KEYCODE_D] = Key.D
        map[KeyEvent.KEYCODE_E] = Key.E
        map[KeyEvent.KEYCODE_F] = Key.F
        map[KeyEvent.KEYCODE_G] = Key.G
        map[KeyEvent.KEYCODE_H] = Key.H
        map[KeyEvent.KEYCODE_I] = Key.I
        map[KeyEvent.KEYCODE_J] = Key.J
        map[KeyEvent.KEYCODE_K] = Key.K
        map[KeyEvent.KEYCODE_L] = Key.L
        map[KeyEvent.KEYCODE_M] = Key.M
        map[KeyEvent.KEYCODE_N] = Key.N
        map[KeyEvent.KEYCODE_O] = Key.O
        map[KeyEvent.KEYCODE_P] = Key.P
        map[KeyEvent.KEYCODE_Q] = Key.Q
        map[KeyEvent.KEYCODE_R] = Key.R
        map[KeyEvent.KEYCODE_S] = Key.S
        map[KeyEvent.KEYCODE_T] = Key.T
        map[KeyEvent.KEYCODE_U] = Key.U
        map[KeyEvent.KEYCODE_V] = Key.V
        map[KeyEvent.KEYCODE_W] = Key.W
        map[KeyEvent.KEYCODE_X] = Key.X
        map[KeyEvent.KEYCODE_Y] = Key.Y
        map[KeyEvent.KEYCODE_Z] = Key.Z
        map[KeyEvent.KEYCODE_0] = Key.N0
        map[KeyEvent.KEYCODE_1] = Key.N1
        map[KeyEvent.KEYCODE_2] = Key.N2
        map[KeyEvent.KEYCODE_3] = Key.N3
        map[KeyEvent.KEYCODE_4] = Key.N4
        map[KeyEvent.KEYCODE_5] = Key.N5
        map[KeyEvent.KEYCODE_6] = Key.N6
        map[KeyEvent.KEYCODE_7] = Key.N7
        map[KeyEvent.KEYCODE_8] = Key.N8
        map[KeyEvent.KEYCODE_9] = Key.N9
        map[KeyEvent.KEYCODE_11] = Key.N11
        map[KeyEvent.KEYCODE_12] = Key.N12
        map[KeyEvent.KEYCODE_3D_MODE] = Key.N3D_MODE
        map[KeyEvent.KEYCODE_ALT_LEFT] = Key.LEFT_ALT
        map[KeyEvent.KEYCODE_ALT_RIGHT] = Key.RIGHT_ALT
        map[KeyEvent.KEYCODE_CTRL_LEFT] = Key.LEFT_CONTROL
        map[KeyEvent.KEYCODE_CTRL_RIGHT] = Key.RIGHT_CONTROL
        map[KeyEvent.KEYCODE_META_LEFT] = Key.LEFT_SUPER
        map[KeyEvent.KEYCODE_META_RIGHT] = Key.RIGHT_SUPER
        map[KeyEvent.KEYCODE_SHIFT_LEFT] = Key.LEFT_SHIFT
        map[KeyEvent.KEYCODE_SHIFT_RIGHT] = Key.RIGHT_SHIFT
        map[KeyEvent.KEYCODE_SOFT_LEFT] = Key.SOFT_LEFT
        map[KeyEvent.KEYCODE_SOFT_RIGHT] = Key.SOFT_RIGHT
        map[KeyEvent.KEYCODE_APOSTROPHE] = Key.APOSTROPHE
        map[KeyEvent.KEYCODE_APP_SWITCH] = Key.APP_SWITCH
        map[KeyEvent.KEYCODE_ASSIST] = Key.ASSIST
        map[KeyEvent.KEYCODE_AT] = Key.AT
        map[KeyEvent.KEYCODE_AVR_INPUT] = Key.AVR_INPUT
        map[KeyEvent.KEYCODE_AVR_POWER] = Key.AVR_POWER
        map[KeyEvent.KEYCODE_DEL] = Key.BACKSPACE
        map[KeyEvent.KEYCODE_FORWARD_DEL] = Key.DELETE
        map[KeyEvent.KEYCODE_BACK] = Key.BACK
        map[KeyEvent.KEYCODE_BACKSLASH] = Key.BACKSLASH
        map[KeyEvent.KEYCODE_BOOKMARK] = Key.BOOKMARK
        map[KeyEvent.KEYCODE_BREAK] = Key.BREAK
        map[KeyEvent.KEYCODE_BRIGHTNESS_DOWN] = Key.BRIGHTNESS_DOWN
        map[KeyEvent.KEYCODE_BRIGHTNESS_UP] = Key.BRIGHTNESS_UP
        map[KeyEvent.KEYCODE_BUTTON_1] = Key.XBUTTON1
        map[KeyEvent.KEYCODE_BUTTON_2] = Key.XBUTTON2
        map[KeyEvent.KEYCODE_BUTTON_3] = Key.XBUTTON3
        map[KeyEvent.KEYCODE_BUTTON_4] = Key.XBUTTON4
        map[KeyEvent.KEYCODE_BUTTON_5] = Key.XBUTTON5
        map[KeyEvent.KEYCODE_BUTTON_6] = Key.XBUTTON6
        map[KeyEvent.KEYCODE_BUTTON_7] = Key.XBUTTON7
        map[KeyEvent.KEYCODE_BUTTON_8] = Key.XBUTTON8
        map[KeyEvent.KEYCODE_BUTTON_9] = Key.XBUTTON9
        map[KeyEvent.KEYCODE_BUTTON_10] = Key.XBUTTON10
        map[KeyEvent.KEYCODE_BUTTON_11] = Key.XBUTTON11
        map[KeyEvent.KEYCODE_BUTTON_12] = Key.XBUTTON12
        map[KeyEvent.KEYCODE_BUTTON_13] = Key.XBUTTON13
        map[KeyEvent.KEYCODE_BUTTON_14] = Key.XBUTTON14
        map[KeyEvent.KEYCODE_BUTTON_15] = Key.XBUTTON15
        map[KeyEvent.KEYCODE_BUTTON_16] = Key.XBUTTON16
        map[KeyEvent.KEYCODE_BUTTON_A] = Key.XBUTTON_A
        map[KeyEvent.KEYCODE_BUTTON_B] = Key.XBUTTON_B
        map[KeyEvent.KEYCODE_BUTTON_C] = Key.XBUTTON_C
        map[KeyEvent.KEYCODE_BUTTON_L1] = Key.XBUTTON_L1
        map[KeyEvent.KEYCODE_BUTTON_L2] = Key.XBUTTON_L2
        map[KeyEvent.KEYCODE_BUTTON_MODE] = Key.XBUTTON_MODE
        map[KeyEvent.KEYCODE_BUTTON_R1] = Key.XBUTTON_R1
        map[KeyEvent.KEYCODE_BUTTON_R2] = Key.XBUTTON_R2
        map[KeyEvent.KEYCODE_BUTTON_SELECT] = Key.XBUTTON_SELECT
        map[KeyEvent.KEYCODE_BUTTON_START] = Key.XBUTTON_START
        map[KeyEvent.KEYCODE_BUTTON_THUMBL] = Key.XBUTTON_THUMBL
        map[KeyEvent.KEYCODE_BUTTON_THUMBR] = Key.XBUTTON_THUMBR
        map[KeyEvent.KEYCODE_BUTTON_X] = Key.XBUTTON_X
        map[KeyEvent.KEYCODE_BUTTON_Y] = Key.XBUTTON_Y
        map[KeyEvent.KEYCODE_BUTTON_Z] = Key.XBUTTON_Z
        map[KeyEvent.KEYCODE_CALCULATOR] = Key.CALCULATOR
        map[KeyEvent.KEYCODE_CALENDAR] = Key.CALENDAR
        map[KeyEvent.KEYCODE_CALL] = Key.CALL
        map[KeyEvent.KEYCODE_CAMERA] = Key.CAMERA
        map[KeyEvent.KEYCODE_CAPS_LOCK] = Key.CAPS_LOCK
        map[KeyEvent.KEYCODE_CAPTIONS] = Key.CAPTIONS
        map[KeyEvent.KEYCODE_CHANNEL_DOWN] = Key.CHANNEL_DOWN
        map[KeyEvent.KEYCODE_CHANNEL_UP] = Key.CHANNEL_UP
        map[KeyEvent.KEYCODE_CLEAR] = Key.CLEAR
        map[KeyEvent.KEYCODE_COMMA] = Key.COMMA
        map[KeyEvent.KEYCODE_CONTACTS] = Key.CONTACTS
        map[KeyEvent.KEYCODE_COPY] = Key.COPY
        map[KeyEvent.KEYCODE_CUT] = Key.CUT
        map[KeyEvent.KEYCODE_DPAD_LEFT] = Key.LEFT
        map[KeyEvent.KEYCODE_DPAD_RIGHT] = Key.RIGHT
        map[KeyEvent.KEYCODE_DPAD_UP] = Key.UP
        map[KeyEvent.KEYCODE_DPAD_DOWN] = Key.DOWN
        map[KeyEvent.KEYCODE_DPAD_CENTER] = Key.RETURN
        map[KeyEvent.KEYCODE_DPAD_DOWN_LEFT] = Key.DPAD_DOWN_LEFT
        map[KeyEvent.KEYCODE_DPAD_DOWN_RIGHT] = Key.DPAD_DOWN_RIGHT
        map[KeyEvent.KEYCODE_DPAD_UP_LEFT] = Key.DPAD_UP_LEFT
        map[KeyEvent.KEYCODE_DPAD_UP_RIGHT] = Key.DPAD_UP_RIGHT
        map[KeyEvent.KEYCODE_DVR] = Key.DVR
        map[KeyEvent.KEYCODE_EISU] = Key.EISU
        map[KeyEvent.KEYCODE_ENDCALL] = Key.ENDCALL
        map[KeyEvent.KEYCODE_ENTER] = Key.ENTER
        map[KeyEvent.KEYCODE_ENVELOPE] = Key.ENVELOPE
        map[KeyEvent.KEYCODE_EQUALS] = Key.KP_EQUAL
        map[KeyEvent.KEYCODE_ESCAPE] = Key.ESCAPE
        map[KeyEvent.KEYCODE_EXPLORER] = Key.EXPLORER
        map[KeyEvent.KEYCODE_F1] = Key.F1
        map[KeyEvent.KEYCODE_F2] = Key.F2
        map[KeyEvent.KEYCODE_F3] = Key.F3
        map[KeyEvent.KEYCODE_F4] = Key.F4
        map[KeyEvent.KEYCODE_F5] = Key.F5
        map[KeyEvent.KEYCODE_F6] = Key.F6
        map[KeyEvent.KEYCODE_F7] = Key.F7
        map[KeyEvent.KEYCODE_F8] = Key.F8
        map[KeyEvent.KEYCODE_F9] = Key.F9
        map[KeyEvent.KEYCODE_F10] = Key.F10
        map[KeyEvent.KEYCODE_F11] = Key.F11
        map[KeyEvent.KEYCODE_F12] = Key.F12
        map[KeyEvent.KEYCODE_FOCUS] = Key.FOCUS
        map[KeyEvent.KEYCODE_FORWARD] = Key.FORWARD
        map[KeyEvent.KEYCODE_FUNCTION] = Key.FUNCTION
        map[KeyEvent.KEYCODE_GRAVE] = Key.GRAVE
        map[KeyEvent.KEYCODE_GUIDE] = Key.GUIDE
        map[KeyEvent.KEYCODE_HEADSETHOOK] = Key.HEADSETHOOK
        map[KeyEvent.KEYCODE_HELP] = Key.HELP
        map[KeyEvent.KEYCODE_HENKAN] = Key.HENKAN
        map[KeyEvent.KEYCODE_HOME] = Key.HOME
        map[KeyEvent.KEYCODE_INFO] = Key.INFO
        map[KeyEvent.KEYCODE_INSERT] = Key.INSERT
        map[KeyEvent.KEYCODE_KANA] = Key.KANA
        map[KeyEvent.KEYCODE_KATAKANA_HIRAGANA] = Key.KATAKANA_HIRAGANA
        map[KeyEvent.KEYCODE_LANGUAGE_SWITCH] = Key.LANGUAGE_SWITCH
        map[KeyEvent.KEYCODE_LAST_CHANNEL] = Key.LAST_CHANNEL
        map[KeyEvent.KEYCODE_LEFT_BRACKET] = Key.LEFT_BRACKET
        map[KeyEvent.KEYCODE_MANNER_MODE] = Key.MANNER_MODE
        map[KeyEvent.KEYCODE_MEDIA_AUDIO_TRACK] = Key.MEDIA_AUDIO_TRACK
        map[KeyEvent.KEYCODE_MEDIA_CLOSE] = Key.MEDIA_CLOSE
        map[KeyEvent.KEYCODE_MEDIA_EJECT] = Key.MEDIA_EJECT
        map[KeyEvent.KEYCODE_MEDIA_FAST_FORWARD] = Key.MEDIA_FAST_FORWARD
        map[KeyEvent.KEYCODE_MEDIA_NEXT] = Key.MEDIA_NEXT_TRACK
        map[KeyEvent.KEYCODE_MEDIA_PAUSE] = Key.MEDIA_PAUSE
        map[KeyEvent.KEYCODE_MEDIA_PLAY] = Key.MEDIA_PLAY
        map[KeyEvent.KEYCODE_MEDIA_PLAY_PAUSE] = Key.MEDIA_PLAY_PAUSE
        map[KeyEvent.KEYCODE_MEDIA_PREVIOUS] = Key.MEDIA_PREV_TRACK
        map[KeyEvent.KEYCODE_MEDIA_RECORD] = Key.MEDIA_RECORD
        map[KeyEvent.KEYCODE_MEDIA_REWIND] = Key.MEDIA_REWIND
        map[KeyEvent.KEYCODE_MEDIA_SKIP_BACKWARD] = Key.MEDIA_SKIP_BACKWARD
        map[KeyEvent.KEYCODE_MEDIA_SKIP_FORWARD] = Key.MEDIA_SKIP_FORWARD
        map[KeyEvent.KEYCODE_MEDIA_STEP_BACKWARD] = Key.MEDIA_STEP_BACKWARD
        map[KeyEvent.KEYCODE_MEDIA_STEP_FORWARD] = Key.MEDIA_STEP_FORWARD
        map[KeyEvent.KEYCODE_MEDIA_STOP] = Key.MEDIA_STOP
        map[KeyEvent.KEYCODE_MEDIA_TOP_MENU] = Key.MEDIA_TOP_MENU
        map[KeyEvent.KEYCODE_MENU] = Key.MENU
        map[KeyEvent.KEYCODE_MINUS] = Key.MINUS
        map[KeyEvent.KEYCODE_MOVE_END] = Key.END
        map[KeyEvent.KEYCODE_MOVE_HOME] = Key.HOME
        map[KeyEvent.KEYCODE_MUHENKAN] = Key.MUHENKAN
        map[KeyEvent.KEYCODE_MUSIC] = Key.MUSIC
        map[KeyEvent.KEYCODE_MUTE] = Key.MUTE
        map[KeyEvent.KEYCODE_NAVIGATE_IN] = Key.NAVIGATE_IN
        map[KeyEvent.KEYCODE_NAVIGATE_NEXT] = Key.NAVIGATE_NEXT
        map[KeyEvent.KEYCODE_NAVIGATE_OUT] = Key.NAVIGATE_OUT
        map[KeyEvent.KEYCODE_NAVIGATE_PREVIOUS] = Key.NAVIGATE_PREVIOUS
        map[KeyEvent.KEYCODE_NOTIFICATION] = Key.NOTIFICATION
        map[KeyEvent.KEYCODE_NUM] = Key.NUM
        map[KeyEvent.KEYCODE_NUMPAD_0] = Key.NUMPAD0
        map[KeyEvent.KEYCODE_NUMPAD_1] = Key.NUMPAD1
        map[KeyEvent.KEYCODE_NUMPAD_2] = Key.NUMPAD2
        map[KeyEvent.KEYCODE_NUMPAD_3] = Key.NUMPAD3
        map[KeyEvent.KEYCODE_NUMPAD_4] = Key.NUMPAD4
        map[KeyEvent.KEYCODE_NUMPAD_5] = Key.NUMPAD5
        map[KeyEvent.KEYCODE_NUMPAD_6] = Key.NUMPAD6
        map[KeyEvent.KEYCODE_NUMPAD_7] = Key.NUMPAD7
        map[KeyEvent.KEYCODE_NUMPAD_8] = Key.NUMPAD8
        map[KeyEvent.KEYCODE_NUMPAD_9] = Key.NUMPAD9
        map[KeyEvent.KEYCODE_NUMPAD_ADD] = Key.KP_ADD
        map[KeyEvent.KEYCODE_NUMPAD_COMMA] = Key.KP_COMMA
        map[KeyEvent.KEYCODE_NUMPAD_DIVIDE] = Key.KP_DIVIDE
        map[KeyEvent.KEYCODE_NUMPAD_DOT] = Key.KP_DOT
        map[KeyEvent.KEYCODE_NUMPAD_ENTER] = Key.KP_DIVIDE
        map[KeyEvent.KEYCODE_NUMPAD_EQUALS] = Key.KP_EQUAL
        map[KeyEvent.KEYCODE_NUMPAD_LEFT_PAREN] = Key.KP_LEFT_PAREN
        map[KeyEvent.KEYCODE_NUMPAD_MULTIPLY] = Key.KP_MULTIPLY
        map[KeyEvent.KEYCODE_NUMPAD_RIGHT_PAREN] = Key.KP_RIGHT_PAREN
        map[KeyEvent.KEYCODE_NUMPAD_SUBTRACT] = Key.KP_SUBTRACT
        map[KeyEvent.KEYCODE_NUM_LOCK] = Key.NUM_LOCK
        map[KeyEvent.KEYCODE_PAGE_DOWN] = Key.PAGE_DOWN
        map[KeyEvent.KEYCODE_PAGE_UP] = Key.PAGE_UP
        map[KeyEvent.KEYCODE_PAIRING] = Key.PAIRING
        map[KeyEvent.KEYCODE_PASTE] = Key.PASTE
        map[KeyEvent.KEYCODE_PERIOD] = Key.PERIOD
        map[KeyEvent.KEYCODE_PICTSYMBOLS] = Key.PICTSYMBOLS
        map[KeyEvent.KEYCODE_PLUS] = Key.PLUS
        map[KeyEvent.KEYCODE_POUND] = Key.POUND
        map[KeyEvent.KEYCODE_POWER] = Key.POWER
        map[KeyEvent.KEYCODE_PROG_BLUE] = Key.PROG_BLUE
        map[KeyEvent.KEYCODE_PROG_GREEN] = Key.PROG_GREEN
        map[KeyEvent.KEYCODE_PROG_RED] = Key.PROG_RED
        map[KeyEvent.KEYCODE_PROG_YELLOW] = Key.PROG_YELLOW
        map[KeyEvent.KEYCODE_RIGHT_BRACKET] = Key.RIGHT_BRACKET
        map[KeyEvent.KEYCODE_RO] = Key.RO
        map[KeyEvent.KEYCODE_SCROLL_LOCK] = Key.SCROLL_LOCK
        map[KeyEvent.KEYCODE_SEARCH] = Key.SEARCH
        map[KeyEvent.KEYCODE_SEMICOLON] = Key.SEMICOLON
        map[KeyEvent.KEYCODE_SETTINGS] = Key.SETTINGS
        map[KeyEvent.KEYCODE_SLASH] = Key.SLASH
        map[KeyEvent.KEYCODE_SLEEP] = Key.SLEEP
        map[KeyEvent.KEYCODE_SOFT_SLEEP] = Key.SOFT_SLEEP
        map[KeyEvent.KEYCODE_SPACE] = Key.SPACE
        map[KeyEvent.KEYCODE_STAR] = Key.STAR
        map[KeyEvent.KEYCODE_STB_INPUT] = Key.STB_INPUT
        map[KeyEvent.KEYCODE_STB_POWER] = Key.STB_POWER
        map[KeyEvent.KEYCODE_STEM_1] = Key.STEM_1
        map[KeyEvent.KEYCODE_STEM_2] = Key.STEM_2
        map[KeyEvent.KEYCODE_STEM_3] = Key.STEM_3
        map[KeyEvent.KEYCODE_STEM_PRIMARY] = Key.STEM_PRIMARY
        map[KeyEvent.KEYCODE_SWITCH_CHARSET] = Key.SWITCH_CHARSET
        map[KeyEvent.KEYCODE_SYM] = Key.SYM
        map[KeyEvent.KEYCODE_SYSRQ] = Key.SYSRQ
        map[KeyEvent.KEYCODE_SYSTEM_NAVIGATION_DOWN] = Key.SYSTEM_NAVIGATION_DOWN
        map[KeyEvent.KEYCODE_SYSTEM_NAVIGATION_LEFT] = Key.SYSTEM_NAVIGATION_LEFT
        map[KeyEvent.KEYCODE_SYSTEM_NAVIGATION_RIGHT] = Key.SYSTEM_NAVIGATION_RIGHT
        map[KeyEvent.KEYCODE_SYSTEM_NAVIGATION_UP] = Key.SYSTEM_NAVIGATION_UP
        map[KeyEvent.KEYCODE_TAB] = Key.TAB
        map[KeyEvent.KEYCODE_TV] = Key.TV
        map[KeyEvent.KEYCODE_TV_ANTENNA_CABLE] = Key.TV_ANTENNA_CABLE
        map[KeyEvent.KEYCODE_TV_AUDIO_DESCRIPTION] = Key.TV_AUDIO_DESCRIPTION
        map[KeyEvent.KEYCODE_TV_AUDIO_DESCRIPTION_MIX_DOWN] = Key.TV_AUDIO_DESCRIPTION_MIX_DOWN
        map[KeyEvent.KEYCODE_TV_AUDIO_DESCRIPTION_MIX_UP] = Key.TV_AUDIO_DESCRIPTION_MIX_UP
        map[KeyEvent.KEYCODE_TV_CONTENTS_MENU] = Key.TV_CONTENTS_MENU
        map[KeyEvent.KEYCODE_TV_DATA_SERVICE] = Key.TV_DATA_SERVICE
        map[KeyEvent.KEYCODE_TV_INPUT] = Key.TV_INPUT
        map[KeyEvent.KEYCODE_TV_INPUT_COMPONENT_1] = Key.TV_INPUT_COMPONENT_1
        map[KeyEvent.KEYCODE_TV_INPUT_COMPONENT_2] = Key.TV_INPUT_COMPONENT_2
        map[KeyEvent.KEYCODE_TV_INPUT_COMPOSITE_1] = Key.TV_INPUT_COMPOSITE_1
        map[KeyEvent.KEYCODE_TV_INPUT_COMPOSITE_2] = Key.TV_INPUT_COMPOSITE_2
        map[KeyEvent.KEYCODE_TV_INPUT_HDMI_1] = Key.TV_INPUT_HDMI_1
        map[KeyEvent.KEYCODE_TV_INPUT_HDMI_2] = Key.TV_INPUT_HDMI_2
        map[KeyEvent.KEYCODE_TV_INPUT_HDMI_3] = Key.TV_INPUT_HDMI_3
        map[KeyEvent.KEYCODE_TV_INPUT_HDMI_4] = Key.TV_INPUT_HDMI_4
        map[KeyEvent.KEYCODE_TV_INPUT_VGA_1] = Key.TV_INPUT_VGA_1
        map[KeyEvent.KEYCODE_TV_MEDIA_CONTEXT_MENU] = Key.TV_MEDIA_CONTEXT_MENU
        map[KeyEvent.KEYCODE_TV_NETWORK] = Key.TV_NETWORK
        map[KeyEvent.KEYCODE_TV_NUMBER_ENTRY] = Key.TV_NUMBER_ENTRY
        map[KeyEvent.KEYCODE_TV_POWER] = Key.TV_POWER
        map[KeyEvent.KEYCODE_TV_RADIO_SERVICE] = Key.TV_RADIO_SERVICE
        map[KeyEvent.KEYCODE_TV_SATELLITE] = Key.TV_SATELLITE
        map[KeyEvent.KEYCODE_TV_SATELLITE_BS] = Key.TV_SATELLITE_BS
        map[KeyEvent.KEYCODE_TV_SATELLITE_CS] = Key.TV_SATELLITE_CS
        map[KeyEvent.KEYCODE_TV_SATELLITE_SERVICE] = Key.TV_SATELLITE_SERVICE
        map[KeyEvent.KEYCODE_TV_TELETEXT] = Key.TV_TELETEXT
        map[KeyEvent.KEYCODE_TV_TERRESTRIAL_ANALOG] = Key.TV_TERRESTRIAL_ANALOG
        map[KeyEvent.KEYCODE_TV_TERRESTRIAL_DIGITAL] = Key.TV_TERRESTRIAL_DIGITAL
        map[KeyEvent.KEYCODE_TV_TIMER_PROGRAMMING] = Key.TV_TIMER_PROGRAMMING
        map[KeyEvent.KEYCODE_TV_ZOOM_MODE] = Key.TV_ZOOM_MODE
        map[KeyEvent.KEYCODE_UNKNOWN] = Key.UNKNOWN
        map[KeyEvent.KEYCODE_VOICE_ASSIST] = Key.VOICE_ASSIST
        map[KeyEvent.KEYCODE_VOLUME_DOWN] = Key.VOLUME_DOWN
        map[KeyEvent.KEYCODE_VOLUME_MUTE] = Key.VOLUME_MUTE
        map[KeyEvent.KEYCODE_VOLUME_UP] = Key.VOLUME_UP
        map[KeyEvent.KEYCODE_WAKEUP] = Key.WAKEUP
        map[KeyEvent.KEYCODE_WINDOW] = Key.WINDOW
        map[KeyEvent.KEYCODE_YEN] = Key.YEN
        map[KeyEvent.KEYCODE_ZENKAKU_HANKAKU] = Key.ZENKAKU_HANKAKU
        map[KeyEvent.KEYCODE_ZOOM_IN] = Key.ZOOM_IN
        map[KeyEvent.KEYCODE_ZOOM_OUT] = Key.ZOOM_OUT
    }
}
